﻿using System;
using System.Drawing;
using System.Windows.Forms;
namespace LED_Monitor
{
    public partial class Form1 : Form
    {
        Label[] block = new Label[256];
        Byte[] inst = { 0x01, 0x02, 0x03, 0x11, 0x12, 0x13, 0x14, 0x21, 0x22, 0x23, 0x24, 0x31, 0x32, 0x33, 0x34, 0x35 };
        Byte[] inst0 = { 0x04, 0x05, 0x06 };
        int number = 1000;
        int tt = 1;
        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < 256; i++)
            {
                block[i] = new Label();
                Controls.Add(block[i]);
                block[i].Location = new Point(10 + 20 * (i % 16), 10 + 20 * (i / 16));
                block[i].Size = new Size(21, 21);
                block[i].BorderStyle = BorderStyle.FixedSingle;
            }
            COM.Text = "1";
            COM.Select(1, 0);
        }
        private void button1_Click(object sender, EventArgs e)
        {
            if (button1.Text == "退出")
            {
                Application.Exit();
            }
            else
            {
                try
                {
                    UART.PortName += COM.Text;
                    UART.Open();
                    MessageBox.Show("COM口打开成功！", "提示");
                    button1.Text = "退出"; button01.Enabled = true;
                    button02.Enabled = true;
                    button03.Enabled = true;
                    button11.Enabled = true;
                    button12.Enabled = true;
                    button13.Enabled = true;
                    button14.Enabled = true;
                    button21.Enabled = true;
                    button22.Enabled = true;
                    button23.Enabled = true;
                    button24.Enabled = true;
                    button04.Enabled = true;
                    button05.Enabled = true;
                    button06.Enabled = true;
                    Time.Enabled = true;
                    timer2.Enabled = true;
                }
                catch
                {
                    MessageBox.Show("COM口打开失败！", "警告");
                    UART.PortName = "COM";
                }
            }
        }
        private void UART_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            if (number != 1000)
            {
                block[number].BackColor = SystemColors.Control;
            }
            int temp = UART.ReadByte();
            if (temp == 0) number = 255;
            else number = temp - 1;
            block[number].BackColor = Color.Red;
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            if (number != 1000)
            {
                Place.Text = "(" + (number / 16 + 1).ToString() + "," + (number % 16 + 1).ToString() + ")";
            }
        }
        private void button01_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 0, 1);
        }
        private void button02_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 1, 1);
        }
        private void button03_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 2, 1);
        }
        private void button11_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 3, 1);
        }
        private void button12_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 4, 1);
        }
        private void button13_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 5, 1);
        }
        private void button14_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 6, 1);
        }
        private void button21_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 7, 1);
        }
        private void button22_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 8, 1);
        }
        private void button23_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 9, 1);
        }
        private void button24_Click(object sender, EventArgs e)
        {
            UART.Write(inst, 10, 1);
        }
        private void Time_ValueChanged(object sender, EventArgs e)
        {
            if (tt != Time.Value)
            {
                tt = Time.Value;
                if (Time.Value == 1)
                {
                    UART.Write(inst, 11, 1);
                }
                else if (Time.Value == 2)
                {
                    UART.Write(inst, 12, 1);
                }
                else if (Time.Value == 3)
                {
                    UART.Write(inst, 13, 1);
                }
                else if (Time.Value == 4)
                {
                    UART.Write(inst, 14, 1);
                }
                else
                {
                    UART.Write(inst, 15, 1);
                }
            }
        }
        private void button04_Click(object sender, EventArgs e)
        {
            UART.Write(inst0, 0, 1);
        }
        private void button05_Click(object sender, EventArgs e)
        {
            UART.Write(inst0, 1, 1);
        }
        private void button06_Click(object sender, EventArgs e)
        {
            UART.Write(inst0, 2, 1);
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            if (Time.Value == 1)
            {
                UART.Write(inst, 11, 1);
            }
            else if (Time.Value == 2)
            {
                UART.Write(inst, 12, 1);
            }
            else if (Time.Value == 3)
            {
                UART.Write(inst, 13, 1);
            }
            else if (Time.Value == 4)
            {
                UART.Write(inst, 14, 1);
            }
            else
            {
                UART.Write(inst, 15, 1);
            }
        }
    }
}